AppTitle "STARToons - Escape From Andricon"

Graphics3D 800,600,32
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Type MazeWallType
	Field x,z,ent
End Type

Type PlayerShotType
	Field sprite,life,ang
End Type

Type FireType
	Field sprite,frame,frametimer
End Type

Type enemytype
	Field entity,entity2,lastnode,destnode,hp,ft,pa,ca,shadow,evilhillary,bounce,spin,gun1,gun2
End Type

Type mazedamagetype
	Field sprite
End Type

Type enemyshottype
	Field sprite,superenemy,rotang
End Type

Type particletype
	Field sprite,mx#,my#,mz#
End Type

Type explosiontype
	Field sprite1,size#,alpha#,typ
End Type

Type robotpiecetype
	Field mx#,my#,mz#,rx#,ry#,rz#,entity,typ
End Type

Type probotpiecetype
	Field entity
End Type

Type explosionsoundtype
	Field entity
End Type

Type SmokeType
	Field Sprite,size#,alpha#,decay#,ang
End Type	

;FONTS
Global LargeFont=LoadFont("Arial",50,True,False,False)
Global SmallFont=LoadFont("arial",20,False,False,False)

;LOAD 2D GRAPHICS
Global TitleScreenImg=LoadImage("2dgfx\title.jpg")
Global YouLoseScreenImg=LoadImage("2dgfx\gamelost.jpg")
Global YouWinScreenImg=LoadImage("2dgfx\gamewon.jpg")

;LOAD TEXTURES
Dim SkyTexture(5,3),WallTex(6),FloorTex(6),DoorTex(5)
Global Wall1Texture=LoadTexture("textures\wall1.png")
Global Wall2Texture=LoadTexture("textures\wall2.png")
Global Wall3Texture=LoadTexture("textures\wall3.png")
Global Wall4Texture=LoadTexture("textures\wall4.png")
Global Wall5Texture=LoadTexture("textures\wall5.png")
Global Wall6Texture=LoadTexture("textures\wall6.png")
Global Wall10Texture=LoadTexture("textures\wall10.png")
Global MazeTextureFloorAndCeiling=LoadTexture("textures\floorceilingtile.jpg"):ScaleTexture MazeTextureFloorAndCeiling,0.05,0.05
Global CyborgVixenSkin=LoadTexture("textures\Cyborg.jpg")
Global EvilHillarySkin=LoadTexture("textures\Super Enemy.jpg")
Global WeaponSkin=LoadTexture("textures\gun.jpg")
Global NeroTexture=LoadTexture("textures\nero.jpg")
Global NikkiTexture=LoadTexture("textures\nikki.jpg")
SkyTexture(1,1)=LoadTexture("textures\sky - 1 - 1.png",3)
SkyTexture(1,2)=LoadTexture("textures\sky - 1 - 2.png",3)
SkyTexture(1,3)=LoadTexture("textures\sky - 1 - 3.png",3)
SkyTexture(2,1)=LoadTexture("textures\sky - 2 - 1.png",3)
SkyTexture(2,2)=LoadTexture("textures\sky - 2 - 2.png",3)
SkyTexture(2,3)=LoadTexture("textures\sky - 2 - 3.png",3)
SkyTexture(3,1)=LoadTexture("textures\sky - 3 - 1.png",3)
SkyTexture(3,2)=LoadTexture("textures\sky - 3 - 2.png",3)
SkyTexture(3,3)=LoadTexture("textures\sky - 3 - 3.png",3)
SkyTexture(4,1)=LoadTexture("textures\sky - 4 - 1.png",3)
SkyTexture(4,2)=LoadTexture("textures\sky - 4 - 2.png",3)
SkyTexture(4,3)=LoadTexture("textures\sky - 4 - 3.png",3)
SkyTexture(5,1)=LoadTexture("textures\sky - 5 - 1.png",3)
SkyTexture(5,2)=LoadTexture("textures\sky - 5 - 2.png",3)
SkyTexture(5,3)=LoadTexture("textures\sky - 5 - 3.png",3)
For a=1 To 6
	WallTex(a)=LoadTexture("textures\walltex"+a+".jpg")
	FloorTex(a)=LoadTexture("textures\floortex"+a+".jpg")
	ScaleTexture WallTex(a),0.2,0.2:ScaleTexture FloorTex(a),0.1,0.1
Next
DoorTex(1)=LoadTexture("textures\door - 1.jpg")
DoorTex(2)=LoadTexture("textures\door - 2.jpg")
DoorTex(3)=LoadTexture("textures\door - 3.jpg")
DoorTex(4)=LoadTexture("textures\door - 4.jpg")
DoorTex(5)=LoadTexture("textures\door - 5.jpg")
Global StarFieldTex=LoadTexture("textures\starfield.jpg")
Global FireTex=LoadAnimTexture("sprites\fire.png",3,256,256,0,6)

;LOAD MESHES, CREATE ENTITIES
Global Wall1Mesh=LoadMesh("meshes\wall1.b3d"):HideEntity Wall1Mesh
Global Wall2Mesh=LoadMesh("meshes\wall2.b3d"):HideEntity Wall2Mesh
Global Wall3Mesh=LoadMesh("meshes\wall3.b3d"):HideEntity Wall3Mesh
Global Wall4Mesh=LoadMesh("meshes\wall4.b3d"):HideEntity Wall4Mesh
Global Wall5Mesh=LoadMesh("meshes\wall5.b3d"):HideEntity Wall5Mesh
Global Wall6Mesh=LoadMesh("meshes\wall6.b3d"):HideEntity Wall6Mesh
Global Wall10Mesh=LoadMesh("meshes\wall10.b3d"):HideEntity Wall10Mesh
ScaleEntity Wall1Mesh,1,6,1
ScaleEntity Wall2Mesh,1,6,1
ScaleEntity Wall3Mesh,1,6,1
ScaleEntity Wall4Mesh,1,6,1
ScaleEntity Wall5Mesh,1,6,1
ScaleEntity Wall6Mesh,1,6,1
ScaleEntity Wall10Mesh,1,6,1

Dim SkyLevel(3)
For a=1 To 3:SkyLevel(a)=CreateCube():ScaleEntity SkyLevel(a),2500,10,2500:Next

Global FloorMesh=LoadMesh("meshes\floor.3ds"):EntityBox FloorMesh,-500,0,-500,1000,10,1000
EntityTexture floormesh,MazeTextureFloorAndCeiling

Global Lysozyme=LoadAnimMesh("meshes\Nikki.b3d"):ScaleEntity Lysozyme,0.7,0.7,0.7:EntityColor Lysozyme,255,255,255:EntityRadius Lysozyme,10
EntityBox Lysozyme,-15,0,-15,30,40,30
EntityTexture Lysozyme,NikkiTexture
ExtractAnimSeq Lysozyme,1,8   ;Standing
ExtractAnimSeq Lysozyme,11,23  ;Running
ExtractAnimSeq Lysozyme,28,38  ;Death
Global WeaponMesh=LoadMesh("meshes\gun.b3d"):EntityColor WeaponMesh,255,255,255:ScaleEntity WeaponMesh,0.1,0.1,0.1:HideEntity WeaponMesh
EntityTexture WeaponMesh,WeaponSkin
Global AimingGuide=LoadMesh("meshes\aimingguide.b3d"):EntityColor AimingGuide,255,0,0:EntityFX AimingGuide,1:ScaleEntity AimingGuide,0.9,0.9,1

Global CyborgVixen=LoadAnimMesh("meshes\cyborg.b3d"):ScaleEntity CyborgVixen,1,1,1:EntityColor CyborgVixen,255,255,255
EntityShininess CyborgVixen,0.4
EntityBox CyborgVixen,-20,0,-20,40,40,40
EntityTexture CyborgVixen,CyborgVixenSkin
ExtractAnimSeq CyborgVixen,1,12      ;Standing
ExtractAnimSeq CyborgVixen,13,25    ;Walking
ExtractAnimSeq CyborgVixen,26,28    ;Shooting
HideEntity CyborgVixen

Global NeroMesh=LoadAnimMesh("meshes\nero.b3d"):ScaleEntity NeroMesh,0.45,0.45,0.45
EntityTexture NeroMesh,NeroTexture
ExtractAnimSeq NeroMesh,1,9			;Standing
ExtractAnimSeq NeroMesh,10,22		;Walking
HideEntity NeroMesh

Dim RobotPieceMesh(29)
RobotPieceMesh(1)=LoadMesh("meshes\part - calf.b3d")
RobotPieceMesh(2)=LoadMesh("meshes\part - foot.b3d")
RobotPieceMesh(3)=LoadMesh("meshes\part - gun.b3d")
RobotPieceMesh(4)=LoadMesh("meshes\part - head.b3d")
RobotPieceMesh(5)=LoadMesh("meshes\part - hip.b3d")
RobotPieceMesh(6)=LoadMesh("meshes\part - hock.b3d")
RobotPieceMesh(7)=LoadMesh("meshes\part - large wing.b3d")
RobotPieceMesh(8)=LoadMesh("meshes\part - lower arm.b3d")
RobotPieceMesh(9)=LoadMesh("meshes\part - neck.b3d")
RobotPieceMesh(10)=LoadMesh("meshes\part - small wing.b3d")
RobotPieceMesh(11)=LoadMesh("meshes\part - tail 1.b3d")
RobotPieceMesh(12)=LoadMesh("meshes\part - tail 2.b3d")
RobotPieceMesh(13)=LoadMesh("meshes\part - tail 3.b3d")
RobotPieceMesh(14)=LoadMesh("meshes\part - tail 4.b3d")
RobotPieceMesh(15)=LoadMesh("meshes\part - tail tip.b3d")
RobotPieceMesh(16)=LoadMesh("meshes\part - thigh.b3d")
RobotPieceMesh(17)=LoadMesh("meshes\part - torso.b3d")
RobotPieceMesh(18)=LoadMesh("meshes\part - upper arm.b3d")
RobotPieceMesh(19)=CopyEntity(RobotPieceMesh(9))
RobotPieceMesh(20)=CopyEntity(RobotPieceMesh(9))
RobotPieceMesh(21)=CopyEntity(RobotPieceMesh(9))
RobotPieceMesh(22)=CopyEntity(RobotPieceMesh(7))
RobotPieceMesh(23)=CopyEntity(RobotPieceMesh(10))
RobotPieceMesh(24)=CopyEntity(RobotPieceMesh(8))
RobotPieceMesh(25)=CopyEntity(RobotPieceMesh(18))
RobotPieceMesh(26)=CopyEntity(RobotPieceMesh(3))
RobotPieceMesh(27)=CopyEntity(RobotPieceMesh(16))
RobotPieceMesh(28)=CopyEntity(RobotPieceMesh(1))
RobotPieceMesh(29)=CopyEntity(RobotPieceMesh(6))

For a=1 To 29
	ScaleEntity RobotPieceMesh(a),1,1,1
	EntityShininess RobotPieceMesh(a),0.4
	EntityColor RobotPieceMesh(a),255,255,255
	EntityRadius RobotPieceMesh(a),5
	HideEntity RobotPieceMesh(a)
	EntityTexture RobotPieceMesh(a),CyborgVixenSkin
Next

Global EvilHillaryMesh=LoadMesh("meshes\Super Enemy.b3d"):HideEntity EvilHillaryMesh
EntityTexture EvilHillaryMesh,EvilHillarySkin
Global MazeBorderMesh=CreateCube():ScaleEntity MazeBorderMesh,500,300,10:HideEntity MazeBorderMesh
Global MazeBorder1=CopyEntity(MazeBorderMesh):PositionEntity MazeBorder1,500,-10,-30
Global MazeBorder2=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder2,0,90,0:PositionEntity MazeBorder2,1030,-10,500
Global MazeBorder3=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder3,0,180,0:PositionEntity MazeBorder3,500,-10,1030
Global MazeBorder4=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder4,0,270,0:PositionEntity MazeBorder4,-30,-10,500
EntityFX MazeBorder1,5:EntityFX MazeBorder2,5:EntityFX MazeBorder3,5:EntityFX MazeBorder4,5
HideEntity MazeBorder1:HideEntity MazeBorder2:HideEntity MazeBorder3:HideEntity MazeBorder4


;CREATE SPRITES
Dim SmokeSprite(4)
Global ShotDamageSprite=LoadSprite("sprites\splat.png"):ScaleSprite ShotDamageSprite,10,10:HideEntity ShotDamageSprite:SpriteViewMode ShotDamageSprite,2:EntityBlend ShotDamageSprite,2
Global EnemyShotSprite=LoadSprite("sprites\Enemy Shot.png",2):ScaleSprite EnemyShotSprite,10,10:HideEntity EnemyShotSprite
Global SuperEnemyShotSprite=LoadSprite("sprites\Super Enemy Shot.png",2):ScaleSprite SuperEnemyShotSprite,20,20:HideEntity SuperEnemyShotSprite 
Global ParticleSprite=LoadSprite("sprites\particle.png"):ScaleSprite ParticleSprite,2,2:HideEntity ParticleSprite:SpriteViewMode ParticleSprite,1
Global ShadowSprite=LoadSprite("sprites\shadow.png"):ScaleSprite ShadowSprite,30,30:HideEntity ShadowSprite:SpriteViewMode ShadowSprite,2:EntityBlend ShadowSprite,2
Global LysozymeShadow=CopyEntity(ShadowSprite)
Global NeroShadow=CopyEntity(ShadowSprite)
For a=1 To 4:SmokeSprite(a)=LoadSprite("sprites\Smoke"+a+".png",3):HideEntity SmokeSprite(a):Next
Global ExplosionSprite=LoadSprite("sprites\explosion.png",3):HideEntity ExplosionSprite
Global PlayerShotSprite=LoadSprite("sprites\player shot.png",3):HideEntity PlayerShotSprite
Global CameraSprite=CreateSprite():ScaleSprite CameraSprite,15,15:EntityColor CameraSprite,255,0,0:EntityAlpha CameraSprite,0:EntityOrder CameraSprite,-1
Global StarToonsLogoSprite=LoadSprite("sprites\startoons logo.png",3):HideEntity StarToonsLogoSprite
Global ScrollingTextSprite=LoadSprite("sprites\scrolling text.png",3):HideEntity ScrollingTextSprite:SpriteViewMode ScrollingTextSprite,2
Global FireSprite=CreateSprite()
Global BlueLettersSprite=LoadSprite("sprites\Blue Letters.png"):HideEntity BlueLettersSprite

;CREATE PIVOTS
Global playershotorigin=CreatePivot(Lysozyme)
Global ExplosionSoundPivot=CreatePivot()
Global LysozymeCameraPivot=CreatePivot(Lysozyme)
EntityParent AimingGuide,playershotorigin
EntityParent WeaponMesh,AimingGuide

;CREATE CAMERA
Global Camera=CreateCamera(LysozymeCameraPivot):EntityRadius camera,5
PositionEntity Camera,0,0,0:PositionEntity CameraSprite,0,0,5
EntityParent CameraSprite,Camera
CameraViewport Camera,0,0,800,600
CameraRange camera,1,10000

;CREATE LIGHTS
Global light=CreateLight(2):LightRange light,1000
Global light2=CreateLight(2):LightRange light2,1000

;COLLISION STUFF
Const coll_Lysozyme=1
Const coll_playershot=2
Const coll_enemyrobot=3
Const coll_mazewall=4
Const coll_enemyshot=5
Const coll_robotpiece=6
Const coll_mazefloor=7
Const coll_mazeceiling=8
Const coll_camera=9

EntityType Lysozyme,coll_Lysozyme
EntityType camera,coll_camera

Collisions coll_playershot,coll_enemyrobot,3,1
Collisions coll_playershot,coll_mazewall,3,1
Collisions coll_playershot,coll_mazefloor,3,1
Collisions coll_Lysozyme,coll_mazewall,3,2
Collisions coll_Lysozyme,coll_enemyrobot,3,2
Collisions coll_enemyshot,coll_mazewall,3,1
Collisions coll_enemyshot,coll_mazefloor,3,1
Collisions coll_particle,coll_mazewall,3,1
Collisions coll_robotpiece,coll_mazewall,3,2
Collisions coll_robotpiece,coll_mazefloor,3,2
Collisions coll_enemyshot,coll_Lysozyme,3,1

Collisions coll_camera,coll_mazewall,3,2
;Collisions coll_camera,coll_mazefloor,3,2
;Collisions coll_camera,coll_mazeceiling,3,2


;SOUNDS
;microphone
Global Microphone=CreateListener(Lysozyme,0.005)
;3D
Dim Taunt(4),PlayerDeathTaunt(2),Laugh(4)
Taunt(1)=Load3DSound("audio\Enemy - Robot 1.mp3")
Taunt(2)=Load3DSound("audio\Enemy - Robot 2.mp3")
Taunt(3)=Load3DSound("audio\Enemy - Robot 3.mp3")
Taunt(4)=Load3DSound("audio\Enemy - Robot 4.mp3")
Laugh(1)=Load3DSound("audio\Enemy - Laugh 1.mp3")
Laugh(2)=Load3DSound("audio\Enemy - Laugh 2.mp3")
Laugh(3)=Load3DSound("audio\Enemy - Laugh 3.mp3")
Laugh(4)=Load3DSound("audio\Enemy - Fool.mp3")
Global SmallExplosionSound=Load3DSound("audio\smallexplosion.mp3"):SoundVolume SmallExplosionSound,0.3
Global LargeExplosionSound=Load3DSound("audio\largeexplosion.mp3")
Global CyborgShootSound=Load3DSound("audio\cyborgshoot.mp3"):SoundVolume CyborgShootSound,0.3

;2D
Dim Grunt(7),NikkiTaunt(6),NeroGripe(4),MusicLoop(5)
Global NikkiTauntChannel,NeroGripeChannel,MusicLoopChannel,MusicLoopNum
Grunt(1)=LoadSound("audio\Nikki - Grunt 1.mp3")
Grunt(2)=LoadSound("audio\Nikki - Grunt 2.mp3")
Grunt(3)=LoadSound("audio\Nikki - Grunt 3.mp3")
Grunt(4)=LoadSound("audio\Nikki - Grunt 4.mp3")
Grunt(5)=LoadSound("audio\Nikki - Grunt 5.mp3")
Grunt(6)=LoadSound("audio\Nikki - Grunt 6.mp3")
Grunt(7)=LoadSound("audio\Nikki - Grunt 7.mp3")
NikkiTaunt(1)=LoadSound("audio\Nikki - Taunt 1.mp3")
NikkiTaunt(2)=LoadSound("audio\Nikki - Taunt 2.mp3")
NikkiTaunt(3)=LoadSound("audio\Nikki - Taunt 3.mp3")
NikkiTaunt(4)=LoadSound("audio\Nikki - Taunt 4.mp3")
NikkiTaunt(5)=LoadSound("audio\Nikki - Taunt 5.mp3")
NikkiTaunt(6)=LoadSound("audio\Nikki - Taunt 6.mp3")
NeroGripe(1)=LoadSound("audio\Nero - Gripe 1.mp3")
NeroGripe(2)=LoadSound("audio\Nero - Gripe 2.mp3")
NeroGripe(3)=LoadSound("audio\Nero - Gripe 3.mp3")
NeroGripe(4)=LoadSound("audio\Nero - Gripe 4.mp3")
MusicLoop(1)=LoadSound("audio\Music - Loop 1.mp3")
MusicLoop(2)=LoadSound("audio\Music - Loop 2.mp3")
MusicLoop(3)=LoadSound("audio\Music - Loop 3.mp3")
MusicLoop(4)=LoadSound("audio\Music - Loop 4.mp3")
MusicLoop(5)=LoadSound("audio\Music - Loop 5.mp3")
Global ScrollingTextMusic=LoadSound("audio\music - scrolling intro.mp3")
Global TitleScreenMusic=LoadSound("audio\music - title.mp3")
Global YouLoseScreenMusic=LoadSound("audio\music - you lost.mp3")
Global YouWinScreenMusic=LoadSound("audio\music - you won.mp3")

Global PlayerDeathSound=LoadSound("audio\Nikki - Death.mp3")
Global PlayerShootSound=LoadSound("audio\playershoot.mp3"):SoundVolume PlayerShootSound,0.2
Global MusicEvilHillaryEnters=LoadSound("audio\Music - Warning.mp3")
Global MusicCyborgsDestroyed=LoadSound("audio\Music - All Enemies Destroyed.mp3")
Global MusicExtraLife=LoadSound("audio\Music - Extra Life.mp3")

;GAME VARIABLES
Const Gravity#=0.1
;Const MouseSensitivity#=0.2
Const ExtraLife=5000

Dim SkyScrollSpeed#(2,2),SkyTexPos#(2,2)
Dim MazePost(4,11,11),MazeExitNode(4,2)
Dim NextNodeDistNo(5),NextNodeDist#(5)
Dim MazeNodeX(25),MazeNodeZ(25),MazeNodeConn(4,25,5),NodeOccupied(25)
Global HeadBob,PlayerDeathTimer,LevelStartTimer,MazeLevel,GameLevel,Score,ppa,pca
Global PlayerFireDelay,NextExtraLife,EvilHillaryTimer,AddedEvilHillary,MouseSensitivity#
Global OriginalRobotsInMaze,CurrentRobotsInMaze,ScoreForLevel,Lives,Health,CurrView,PrevView
Global RobotTurnSpeed#,RobotSpeed#,RobotShootingSpeed,RobotShotSpeed#,RobotTalkTimer,RobotAnimSpeed#,LevelSkyTex
Global MazeTex,DoorTexx,DoorTexPos#,DoorTexBright#,CameraSpriteAlpha#,CameraDist
Global FrameTimer=CreateTimer(60)

;MAZE NODES
;Maze 1
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,8,4,0,0
Data 3,5,0,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 12,13,8,0,0
Data 3,7,9,13,0
Data 8,13,14,0,0
Data 5,15,0,0,0
Data 6,16,0,0,0
Data 7,13,17,8,18
Data 12,14,8,18,0
Data 9,13,19,8,18
Data 10,20,0,0,0
Data 11,21,0,0,0
Data 12,13,18,0,0
Data 23,17,19,13,14
Data 18,13,14,0,0
Data 15,25,0,0,0
Data 16,22,0,0,0
Data 21,23,0,0,0
Data 22,24,18,0,0
Data 23,25,0,0,0
Data 20,24,0,0,0
Data 3,23

;Maze 2
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,4,8,0,0
Data 3,5,0,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 8,12,0,0,0
Data 7,3,9,0,0
Data 8,14,0,0,0
Data 5,15,0,0,0
Data 6,12,16,0,0
Data 7,11,17,13,0
Data 12,14,0,0,0
Data 9,13,19,15,0
Data 10,14,20,0,0
Data 11,21,0,0,0
Data 12,18,0,0,0
Data 17,23,19,0,0
Data 18,14,0,0,0
Data 25,15,0,0,0
Data 16,22,0,0,0
Data 21,23,0,0,0
Data 22,18,24,0,0
Data 23,25,0,0,0
Data 24,20,0,0,0
Data 11,15

;Maze 3
Data 2,6,0,0,0
Data 1,3,7,0,0
Data 2,4,0,0,0
Data 3,9,5,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 2,12,0,0,0
Data 13,0,0,0,0
Data 4,14,0,0,0
Data 5,15,0,0,0
Data 6,16,0,0,0
Data 7,17,13,0,0
Data 8,12,18,14,0
Data 9,13,19,0,0
Data 10,20,0,0,0
Data 11,21,0,0,0
Data 12,22,0,0,0
Data 13,0,0,0,0
Data 14,24,0,0,0
Data 15,25,0,0,0
Data 16,22,0,0,0
Data 21,17,23,0,0
Data 22,24,0,0,0
Data 23,19,25,0,0
Data 20,24,0,0,0
Data 11,15

;Maze 4
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,4,0,0,0
Data 3,9,5,0,0
Data 4,10,0,0,0
Data 1,7,11,0,0
Data 6,8,0,0,0
Data 7,9,0,0,0
Data 4,8,14,0,0
Data 5,15,0,0,0
Data 6,12,16,0,0
Data 11,17,13,0,0
Data 12,14,0,0,0
Data 13,9,15,0,0
Data 10,14,20,0,0
Data 11,21,0,0,0
Data 12,22,18,0,0
Data 19,17,0,0,0
Data 18,20,0,0,0
Data 15,19,25,0,0
Data 16,22,0,0,0
Data 21,17,23,0,0
Data 22,24,0,0,0
Data 23,25,0,0,0
Data 20,24,0,0,0
Data 3,23

;MAZE WALLS	0=empty space  1-6=walls 1-6 long  7=wall 10 long      +10 to rotate 90 deg CW (down)  +20 to rotate 180 deg  +30 to rotate 90 deg CCW (up)
;Maze 1
Data 04,00,00,00,00,00,04,00,00,00,17
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,16,00,22,00,02,00,16,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,22,00,02,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 37,00,00,00,24,00,00,00,00,00,24

;Maze 2
Data 07,00,00,00,00,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,02,00,00,00,02,00,12,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,32,00,02,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,12,00,02,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,02,00,00,00,02,00,32,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,00,00,00,00,00,00,27

;Maze 3
Data 07,00,00,00,00,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,16,00,02,00,00,00,16,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,32,00,32,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,12,00,12,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,02,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,00,00,00,00,00,00,27

;Maze 4
Data 04,00,00,00,00,00,04,00,00,00,17
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,04,00,00,00,00,00,12,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,04,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,12,00,04,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,04,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 37,00,00,00,24,00,00,00,00,00,24

ScrollingTextIntro
TitleScreen
InitializeVariables
NewLevel(1)

PositionEntity Lysozyme,500,0,500:PositionEntity LysozymeCameraPivot,0,30,0


SetLysoAnim(1,0.1)
PositionEntity playershotorigin,507,27,500,1;:TurnEntity playershotorigin,-1,5,0
MoveEntity PlayerShotOrigin,0,12,2
MoveEntity AimingGuide,0,-5,25
MoveEntity WeaponMesh,0,-7,-10
PositionEntity light,500,900,500
PositionEntity light2,500,-900,500
NewPlayer
MoveMouse 300,300

While Not KeyDown(1)		

	kk=GetKey()
	h=0
	If PlayerDeathTimer=0 Then
		If kk=Asc("1") Then CurrView=1
		If kk=Asc("2") Then CurrView=2
		If CurrView=2 Then HeadBob=0
		
		If kk=Asc("P") Or kk=Asc("p") Then
			SetFont LargeFont:Color 255,255,255
			Text 400,300,"PAUSED",True,True
			Flip
			Repeat
				pp=GetKey()			
			Until pp=Asc("P") Or pp=Asc("p")
			MoveMouse 300,300
		EndIf
		
		If EntityYaw(LysozymeCameraPivot)>=2 Then TurnEntity LysozymeCameraPivot,0,-5,0
		If EntityYaw(LysozymeCameraPivot)<=-2 Then TurnEntity LysozymeCameraPivot,0,5,0
		If EntityYaw(LysozymeCameraPivot)>-2 And EntityYaw(LysozymeCameraPivot)<2 Then RotateEntity LysozymeCameraPivot,0,0,0
		
		;Forwards
		If KeyDown(200) Then 
		MoveEntity Lysozyme,0,0,4:PositionEntity Lysozyme,EntityX(Lysozyme),(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(2,0.5)
		EndIf
		;Backwards
		If KeyDown(208) Then 
			MoveEntity Lysozyme,0,0,-4:PositionEntity Lysozyme,EntityX(Lysozyme),(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(4,0.5)
		EndIf
		;Strafe Right
		If KeyDown(205) Then 
			MoveEntity Lysozyme,3,0,0:PositionEntity Lysozyme,EntityX(Lysozyme),0+(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=0
			SetLysoAnim(2,0.5)
		EndIf
		;Strafe Left
		If KeyDown(203) Then 
			MoveEntity Lysozyme,-3,0,0:PositionEntity Lysozyme,EntityX(Lysozyme),0+(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(2,0.5)
		EndIf
	
		If KeyDown(200)=False And KeyDown(208)=False And KeyDown(205)=False And KeyDown(203)=False Then SetLysoAnim(1,0.1)
	
		;Mouse movement
		mx#=MouseXSpeed():my#=MouseYSpeed():MoveMouse 300,300
		TurnEntity Lysozyme,0,-mx*MouseSensitivity,0
		TurnEntity camera,my*MouseSensitivity,0,0
		TurnEntity PlayerShotOrigin,my*MouseSensitivity,0,0
		If currview=2 Then TurnEntity LysozymeCameraPivot,0,mx*MouseSensitivity,0
		If EntityPitch(camera)>70 Then RotateEntity camera,70,0,0:RotateEntity PlayerShotOrigin,70,0,0
		If EntityPitch(camera)<-70 Then RotateEntity camera,-70,0,0:RotateEntity PlayerShotOrigin,-70,0,0
		If CurrView=2 And EntityDistance(camera,Lysozyme)>65 Then 
			RotateEntity LysozymeCameraPivot,0,0,0
			HideEntity camera
			PositionEntity camera,0,0,-40
			ShowEntity camera
		EndIf
	
		If MouseDown(1) And PlayerFireDelay=8 Then AddPlayerShot:PlayerFireDelay=0
		
	EndIf
	
	PlayerFireDelay=PlayerFireDelay+1
	If PlayerFireDelay>5 Then PlayerFireDelay=8
	If HeadBob>359 Then HeadBob=0
	
	LevelStartTimer=LevelStartTimer+1
	If LevelStartTimer>1000 Then LevelStartTimer=1000
	
	If PlayerDeathTimer>0 Then PlayerDeathTimer=PlayerDeathTimer+1
	If PlayerDeathTimer>350 Then PlayerDeathTimer=0
	If PlayerDeathTimer=2 Then 
		CurrView=2
		PlaySound PlayerDeathSound
		PositionEntity Lysozyme,EntityX(Lysozyme),1,EntityZ(Lysozyme)
		Animate Lysozyme,3,0.12,3,1
	EndIf
	If PlayerDeathTimer=200 Then NewPlayer:LevelStartTimer=0:PlayerDeathTimer=0
	
	If EntityX(Lysozyme)>1000 Or EntityX(Lysozyme)<0 Then PositionEntity Lysozyme,500,0,500:EndLevel
	If EntityZ(Lysozyme)>1000 Or EntityZ(Lysozyme)<0 Then PositionEntity Lysozyme,500,0,500:EndLevel
	
	For enemy.enemytype=Each enemytype
		If EntityDistance(Lysozyme,enemy\entity)<(15+(25*enemy\evilhillary)) And LevelStartTimer>=120 Then DamagePlayer(100)
	Next
	;If EntityCollided(Lysozyme,coll_enemyrobot) Then DamagePlayer(100)
	
	RotateEntity LysozymeShadow,90,EntityYaw(Lysozyme),0
	PositionEntity LysozymeShadow,EntityX(Lysozyme),0.1,EntityZ(Lysozyme)
	
	UpdateView
	UpdateNero
	UpdatePlayerShots
	UpdateEnemyRobots
	UpdateEnemyShots
	UpdateParticles
	UpdateExplosions
	UpdateRobotPieces
	UpdateSky
	UpdateSmoke
	UpdateFires
	
	;Adding Evil Hillary
	If AddedEvilHillary=False And LevelStartTimer>=120 Then EvilHillaryTimer=EvilHillaryTimer+1
	If EvilHillaryTimer>=1200 And AddedEvilHillary=False Then 
		AddedEvilHillary=True:w=Rand(1,2)
		cx=MazeNodeX(MazeExitNode(MazeLevel,w))
		cz=MazeNodeZ(MazeExitNode(MazeLevel,w))
		AddEnemyRobot(cx,cz,MazeExitNode(MazeLevel,w),1)
		PlaySound MusicEvilHillaryEnters
	EndIf
	
	If ChannelPlaying(MusicLoopChannel)=False Then 
		MusicLoopChannel=PlaySound(MusicLoop(MusicLoopNum))
		ChannelVolume MusicLoopChannel,0.25
	EndIf
	
	WaitTimer(FrameTimer)
	UpdateWorld
	RenderWorld
	UpdateHUD
	Flip
Wend

Function ScrollingTextIntro()
	a1#=0:t=0
	EntityAlpha Lysozyme,0
	StarDome=CreateSphere(25):ScaleEntity StarDome,500,500,500:FlipMesh StarDome:EntityColor StarDome,255,255,255:RotateEntity StarDome,0,Rand(0,359),0
	EntityTexture StarDome,StarFieldTex:ScaleTexture StarFieldTex,0.15,0.2
	PositionEntity Camera,0,0,0:RotateEntity Camera,0,0,0
	
	ShowEntity BlueLettersSprite:PositionEntity BlueLettersSprite,0,0,1
	EntityColor StarDome,0,0,0
	While Not KeyDown(57)
		t=t+1
		If t>=1 And t<=50 Then 
			a1=a1+0.02:If a1>1 Then a1=1
			EntityAlpha BlueLettersSprite,a1
		EndIf
		
		If t>=300 And t<=350 Then
			a1=a1-0.02
			If a1<0 Then a1=0
			EntityAlpha BlueLettersSprite,a1
		EndIf
		
		If t>400 Then Goto doneblueletters
		
		WaitTimer(FrameTimer)
		UpdateWorld
		RenderWorld
		Flip
		If KeyDown(1) Then End
	Wend
	.doneblueletters
	FlushKeys
	EntityColor StarDome,255,255,255
	HideEntity BlueLettersSprite
	
	
	ShowEntity StarToonsLogoSprite:ScaleSprite StarToonsLogoSprite,5,5:EntityAlpha StarToonsLogoSprite,1:EntityFX StarToonsLogoSprite,17
	PositionEntity StarToonsLogoSprite,0,0.5,4
	ShowEntity ScrollingTextSprite:ScaleSprite Scrollingtextsprite,5,5:RotateEntity ScrollingTextSprite,70,0,0
	PositionEntity ScrollingTextSprite,0,-3,-3:EntityFX ScrollingTextSprite,17
	a1=1:t=0
	ScrollingTextMusicChannel=PlaySound(ScrollingTextMusic)
	While Not KeyDown(57)
		t=t+1
		
		TurnEntity StarDome,0,0.01,0
		
		If t>0 And t<650 Then
			MoveEntity StarToonsLogoSprite,0,0,0.05 
			If t>450 Then 
				a1=a1-0.005
				If a1<0 Then a1=0
				EntityAlpha StarToonsLogoSprite,a1
			EndIf
		EndIf
		
		If t>=650 And t<=4200
			MoveEntity ScrollingTextSprite,0,0.004,0
		EndIf
		
		If t=2700 Then EntityColor CameraSprite,0,0,0:a1=0
	
		If t>4100 And t<=4200 Then
			a1=a1+0.01
			MoveEntity ScrollingTextSprite,0,0.005,0
			EntityAlpha CameraSprite,a1
		EndIf
		
		If t>4200 Then Goto donescrolling
		
		WaitTimer(FrameTimer)
		UpdateWorld
		RenderWorld
		Flip
		If KeyDown(1) Then End
	Wend
	.donescrolling
	FlushKeys
	StopChannel(ScrollingTextMusicChannel)
	EntityColor CameraSprite,255,0,0
	EntityAlpha CameraSprite,0
	FreeEntity StarDome
	HideEntity ScrollingTextSprite:HideEntity StarToonsLogoSprite
	EntityAlpha Lysozyme,1
End Function

;Function SwitchView(v) ;1=FPS  2=From the back  3=From the top
;	If v=CurrView Then Return
;	If v=1 Then
;		PositionEntity camera,0,0,-40
;		RotateEntity camera,0,0,0
;		EntityAlpha Lysozyme,0
;	EndIf
;	If v=2 Then
;		PositionEntity camera,0,0,0
;		RotateEntity camera,0,0,0
;		EntityAlpha Lysozyme,0.6
;	EndIf
;End Function

Function UpdateView()
	If CurrView=1 Then
		If CameraDist>0 Then CameraDist=CameraDist-5
		If CameraDist<10 Then EntityAlpha Lysozyme,0
	EndIf
	If CurrView=2 Then
		If CameraDist>=0 And CameraDist<=69 Then CameraDist=CameraDist+5
		EntityAlpha Lysozyme,1
	EndIf
	PositionEntity Camera,0,0,-CameraDist
	If PlayerDeathTimer=0 Then 
		EntityAlpha AimingGuide,0.3:EntityAlpha WeaponMesh,1
	Else
		EntityAlpha AimingGuide,0:EntityAlpha WeaponMesh,0
	EndIf
End Function

Function TitleScreen()
	mus=PlaySound(TitleScreenMusic)
	Repeat
		Cls
		DrawBlock TitleScreenImg,0,0
		Flip
		kk=GetKey()
	Until kk=Asc(" ")
	StopChannel(mus)
	MouseSensitivity=0.2
	Color 255,255,255:SetFont LargeFont
	Repeat
		Cls
		Text 400,200,"MOUSE SENSITIVITY",True,True
		Text 400,250,MouseSensitivity,True,True
		Text 400,500,"LEFT/RIGHT ARROWS TO CHOOSE",True,True
		Text 400,550,"PRESS SPACE WHEN DONE",True,True
		kk=GetKey()
		If kk=30 Then MouseSensitivity=MouseSensitivity+0.05
		If kk=31 Then MouseSensitivity=MouseSensitivity-0.05
		If MouseSensitivity<=0.05 Then MouseSensitivity=0.05
		If MouseSensitivity>2 Then MouseSensitivity=2
		Flip
	Until kk=32
End Function

Function InitializeVariables()
	co=0
	For x=1 To 5
		For z=1 To 5
			co=co+1
			MazeNodeZ(co)=(z*200)-100
			MazeNodeX(co)=(x*200)-100
		Next
	Next

	For a=1 To 4
		For b=1 To 25
			For c=1 To 5
				Read MazeNodeConn(a,b,c)
			Next
		Next
		Read MazeExitNode(a,1),MazeExitNode(a,2)
	Next

	For lev=1 To 4
		For x=1 To 11
			For z=1 To 11
				Read MazePost(lev,x,z)
			Next
		Next
	Next

	GameLevel=0:Score=0:Lives=5:ppa=0:pca=0:CurrView=2:PrevView=2:CameraDist=0:NextExtraLife=ExtraLife
End Function

Function NewLevel(advance)
	MazeLevel=Rand(1,4):GameLevel=GameLevel+1:ScoreForLevel=0
	PlayerDeathTimer=0:LevelStartTimer=0:Health=100
	EvilHillaryTimer=0:AddedEvilHillary=False:CameraSpriteAlpha=0
	
	If GameLevel>30 Then
		GameOverYouWin
		Return
	EndIf
	
	Cls
	SetFont LargeFont
	Text 400,200,"LEVEL "+GameLevel,True,True
	Flip
	Delay(1000)
	
	MusicLoopNum=Rand(1,5)
	
	For enemy.enemytype=Each enemytype
		FreeEntity enemy\entity
		Delete enemy
	Next
	For enemyshot.enemyshottype=Each enemyshottype
		FreeEntity enemyshot\sprite:Delete enemyshot
	Next
	For smoke.smoketype=Each smoketype
		FreeEntity smoke\sprite:Delete Smoke
	Next
	For fire.firetype=Each firetype
		FreeEntity fire\sprite:Delete Fire
	Next
	For mazedamage.mazedamagetype=Each mazedamagetype
		FreeEntity mazedamage\sprite:Delete mazedamage
	Next
	For playershot.playershottype=Each playershottype
		FreeEntity playershot\sprite:Delete playershot
	Next
	For explosion.explosiontype=Each explosiontype
		FreeEntity explosion\sprite1:Delete explosion
	Next
	For particle.particletype=Each particletype
		FreeEntity particle\sprite:Delete particle
	Next
	
	For robotpiece.robotpiecetype=Each robotpiecetype
		FreeEntity robotpiece\entity:Delete robotpiece
	Next
	
	For probotpiece.probotpiecetype=Each probotpiecetype
		FreeEntity probotpiece\entity:Delete probotpiece
	Next

	For explosionsound.explosionsoundtype=Each explosionsoundtype
		FreeEntity explosionsound\entity:Delete explosionsound
	Next
		
	BuildMaze(MazeLevel)
	For a=1 To 25:NodeOccupied(a)=False:Next
	
	For a=1 To 2
		For b=1 To 2
			SkyScrollSpeed(a,b)=Rnd(-0.002,0.002)
			SkyTexPos(a,b)=0
		Next
	Next
	
	;Add Robots
	NodeOccupied(13)=True
	If GameLevel=1 Then OriginalRobotsInMaze=Rand(3,5)
	If GameLevel>=2 And GameLevel<=5 Then OriginalRobotsInMaze=Rand(5,8)
	If GameLevel>=6 And GameLevel<=10 Then OriginalRobotsInMaze=Rand(6,10)
	If GameLevel>=11 Then OriginalRobotsInMaze=Rand(8,14)
	CurrentRobotsInMaze=OriginalRobotsInMaze
	For r=1 To OriginalRobotsInMaze
		.pick
		start=Rand(1,25)
		If NodeOccupied(start)=True Then Goto pick
		AddEnemyRobot(MazeNodeX(Start),MazeNodeZ(start),start,False)
		NodeOccupied(start)=True
	Next
	l1=GameLevel
	l2=l1
	If l2>10 Then l2=10
	While l1>10
		l1=l1-10
	Wend
	l3#=l1:l4#=l2
	RobotSpeed=1.5+((2.5*l3/10))
	RobotAnimSpeed=0.20*(1+(0.5*(l3/10)))
	RobotTurnSpeed=RobotSpeed*1.5
	RobotShootingSpeed=300/l4
	RobotShotSpeed=3+((4*(l4/10)))
	PositionEntity Lysozyme,500,0,500:RotateEntity Lysozyme,0,0,0:ShowEntity WeaponMesh
	RotateEntity LysozymeCameraPivot,0,0,0:PositionEntity LysozymeCameraPivot,0,55,0
	RotateEntity camera,0,0,0
	RotateEntity AimingGuide,0,0,0
	RotateEntity PlayerShotOrigin,0,0,0
	pca=0:ppa=0:SetLysoAnim(1,0.1)
	
	;Position Nero
	
	Repeat
		PositionEntity NeroMesh,Rand(410,490),0,Rand(410,590)
	Until EntityDistance(NeroMesh,Lysozyme)>40
	ShowEntity NeroMesh
	ShowEntity Lysozyme
	UpdateWorld
End Function

Function UpdateHUD()
	SetFont LargeFont
	Color 0,0,0
	Text 13,13,Score
	Text 753,13,Lives
	Text 693,553,Health+"%"
	Color 255,255,255
	Text 10,10,Score
	Text 750,10,Lives
	Text 690,550,Health+"%"
	
	CameraSpriteAlpha=CameraSpriteAlpha-0.025
	If CameraSpriteAlpha<0 Then CameraSpriteAlpha=0
	EntityAlpha CameraSprite,CameraSpriteAlpha
End Function

Function EndLevel()
	Cls
	
	StopChannel MusicLoopChannel
	SetFont LargeFont
	Text 200,100,"LEVEL "+GameLevel+" DONE"
	Text 100,250,"SCORE THIS LEVEL:"
	Text 100,300,"TOTAL SCORE:"
	Text 550,250,ScoreForLevel
	Text 550,300,Score
	Flip
	
	Delay 2000
	NewLevel(1)
End Function

Function BuildMaze(lev)
	For MazeWall.MazeWallType=Each MazeWallType
		FreeEntity Mazewall\ent:Delete MazeWall
	Next	
	PositionEntity FloorMesh,500,-10,500:EntityType FloorMesh,coll_mazefloor
	MazeTex=Rand(1,6)
	EntityTexture FloorMesh,FloorTex(MazeTex)
	For x=1 To 11
		For z=1 To 11
			xx=(x-1)*100:zz=(z-1)*100
			post1=MazePost(lev,x,z)
			If post1<10 Then r=0
			If post1>=10 And post1<=19 Then r=1:post1=post1-10
			If post1>=20 And post1<=29 Then r=2:post1=post1-20
			If post1>=30 And post1<=39 Then r=3:post1=post1-30
			If post1<>0 Then AddMazeElement(xx,zz,post1,r)
		Next
	Next
	LevelSkyTex=Rand(1,5)
	For a=1 To 3
		PositionEntity SkyLevel(a),500,700+(a*10),500
		EntityTexture SkyLevel(a),SkyTexture(LevelSkyTex,a)
		ScaleTexture SkyTexture(LevelSkyTex,a),0.5,0.5
	Next
	DoorTexx=Rand(1,5)
	EntityTexture MazeBorder1,DoorTex(DoorTexx)
	EntityTexture MazeBorder2,DoorTex(DoorTexx)
	EntityTexture MazeBorder3,DoorTex(DoorTexx)
	EntityTexture MazeBorder4,DoorTex(DoorTexx)
	ShowEntity MazeBorder1
	ShowEntity MazeBorder2
	ShowEntity MazeBorder3
	ShowEntity MazeBorder4
	AddFire(-5000,-5000)
End Function

Function AddMazeElement(x,z,typ,rot) ;typ:1 column, 2 wall   rot 1 means rotate 90 deg clockwise   rot 2 means rotate 90 deg counterclockwise
	mazewall.mazewalltype=New mazewalltype
	mazewall\x=x
	mazewall\z=z
	If typ=1 Then mazewall\ent=CopyEntity(Wall1Mesh):EntityBox mazewall\ent,-10,0,-10,120,300,20
	If typ=2 Then mazewall\ent=CopyEntity(Wall2Mesh):EntityBox mazewall\ent,-10,0,-10,220,300,20
	If typ=3 Then mazewall\ent=CopyEntity(Wall3Mesh):EntityBox mazewall\ent,-10,0,-10,320,300,20
	If typ=4 Then mazewall\ent=CopyEntity(Wall4Mesh):EntityBox mazewall\ent,-10,0,-10,420,300,20
	If typ=5 Then mazewall\ent=CopyEntity(Wall5Mesh):EntityBox mazewall\ent,-10,0,-10,520,300,20
	If typ=6 Then mazewall\ent=CopyEntity(Wall6Mesh):EntityBox mazewall\ent,-10,0,-10,620,300,20
	If typ=7 Then mazewall\ent=CopyEntity(Wall10Mesh):EntityBox mazewall\ent,-10,0,-10,1020,300,20
	EntityTexture mazewall\ent,WallTex(MazeTex)
	If rot=0 Then RotateEntity mazewall\ent,0,90,0
	If rot=2 Then RotateEntity mazewall\ent,0,-90,0
	If rot=3 Then RotateEntity mazewall\ent,0,180,0
	EntityType mazewall\ent,coll_mazewall
	PositionEntity mazewall\ent,mazewall\x,-12,mazewall\z
End Function

Function UpdateNero()
	If Rand(1,1000)=1 And ChannelPlaying(NeroGripeChannel)=False Then NeroGripeChannel=PlaySound(NeroGripe(Rand(1,4)))

	vx#=EntityX(NeroMesh)-EntityX(Lysozyme)
	vy#=EntityY(NeroMesh)-EntityY(Lysozyme)
	vz#=EntityZ(NeroMesh)-EntityZ(Lysozyme)
	
	If EntityDistance(NeroMesh,Lysozyme)>20 Then 
		AlignToVector NeroMesh,-vx,-vy,-vz,3
	Else
		If EntityZ(NeroMesh)<>0 Then RotateEntity NeroMesh,0,EntityY(NeroMesh),0
	EndIf
	
	PositionEntity NeroShadow,EntityX(NeroMesh),0.5,EntityZ(NeroMesh)
	RotateEntity NeroShadow,90,0,0
	If EntityDistance(NeroMesh,Lysozyme)>80 Then
		If AnimSeq(NeroMesh)<>2 Then Animate NeroMesh,1,1,2
		MoveEntity NeroMesh,0,0,4
	Else
		If AnimSeq(NeroMesh)<>1 Then Animate NeroMesh,1,0.25,1
	EndIf
End Function

Function UpdateSky()
	For a=1 To 2
		For b=1 To 2
			SkyTexPos(a,b)=SkyTexPos(a,b)+SkyScrollSpeed(a,b)
		Next
		PositionTexture SkyTexture(LevelSkyTex,a),SkyTexPos(a,1),SkyTexPos(a,2)
	Next
	
	DoorTexPos=DoorTexPos+0.001
	If DoorTexPos>1 Then DoorTexPos=0
	PositionTexture DoorTex(DoorTexx),DoorTexPos,0
	DoorTexBright=DoorTexBright+0.025
	If DoorTexBright>1 Then br#=(2-DoorTexBright) Else br#=DoorTexBright
	If DoorTexBright>2 Then DoorTexBright=0
	br=(br*0.5)+0.5
	EntityColor MazeBorder1,(255*br),(255*br),(255*br)
	EntityColor MazeBorder2,(255*br),(255*br),(255*br)
	EntityColor MazeBorder3,(255*br),(255*br),(255*br)
	EntityColor MazeBorder4,(255*br),(255*br),(255*br)

End Function

Function AddFire(x,z)
	Fire.FireType=New FireType
	Fire\sprite=CopyEntity(FireSprite)
	HandleSprite FireSprite,0,-1
	EntityFX Fire\sprite,1
	ScaleSprite FireSprite,25,50
	PositionEntity Fire\sprite,x,0,z
	EntityTexture FireSprite,FireTex,0
	PositionTexture FireTex,0,-0.01
	Fire\frame=0
	Fire\frametimer=0
End Function

Function UpdateFires()
	For Fire.FireType=Each FireType
		Fire\frametimer=Fire\frametimer+1
		If Fire\frametimer>=3 Then
			Fire\frametimer=0
			Fire\frame=Fire\frame+1
			If Fire\frame>5 Then Fire\frame=0
			EntityTexture Fire\sprite,FireTex,Fire\frame
		EndIf
		;If Rand(1,80)=1 Then AddSmoke(EntityX(Fire\sprite),5,EntityZ(Fire\sprite),0.01)
		If EntityDistance(Fire\sprite,Lysozyme)<=30 And Rand(1,10)=1 And LevelStartTimer>120 Then DamagePlayer(Rand(1,4)):CameraSpriteAlpha=0.5
	Next
End Function

Function AddSmoke(x,y,z,d#)
	Smoke.SmokeType=New SmokeType
	Smoke\sprite=CopyEntity(SmokeSprite(Rand(1,4)))
	PositionEntity Smoke\sprite,x,y,z
	Smoke\alpha=1
	Smoke\size=5
	Smoke\decay=d:Smoke\ang=Rand(0,359)
	ScaleSprite Smoke\sprite,size,size
End Function

Function UpdateSmoke()
	For Smoke.SmokeType=Each SmokeType
		Smoke\ang=Smoke\ang+5:If Smoke\ang>359 Then Smoke\ang=Smoke\ang-360
		ScaleSprite Smoke\sprite,Smoke\size,Smoke\size
		RotateSprite Smoke\sprite,Smoke\ang
		EntityAlpha Smoke\sprite,Smoke\alpha
		Smoke\alpha=Smoke\alpha-Smoke\decay
		Smoke\size=Smoke\size+1.5
		TranslateEntity Smoke\sprite,0,1,0
		If Smoke\alpha<=0 Then FreeEntity Smoke\sprite:Delete Smoke	
	Next
End Function

Function AddPlayerShot()
	PlaySound PlayerShootSound

	PlayerShot.PlayerShotType=New PlayerShotType
	playershot\sprite=CopyEntity(PlayerShotSprite)
	EntityType playershot\sprite,coll_playershot
	EntityRadius playershot\sprite,4:ScaleSprite Playershot\sprite,25,25
	RotateEntity playershot\sprite,EntityPitch(camera,1),EntityYaw(playershotorigin,1),EntityRoll(playershotorigin,1)
	PositionEntity playershot\sprite,EntityX(playershotorigin,1),EntityY(playershotorigin,1)-7,EntityZ(playershotorigin,1)
	ResetEntity playershot\sprite
	MoveEntity playershot\sprite,0,0,10
	playershot\life=100
End Function

Function UpdatePlayerShots()
	For playershot.playershottype=Each playershottype
		MoveEntity playershot\sprite,0,0,15
		playershot\ang=playershot\ang+15
		If playershot\ang>359 Then playershot\ang=0
		RotateSprite playershot\sprite,playershot\ang
		If EntityX(playershot\sprite)>1100 Or EntityX(playershot\sprite)<-100 Then FreeEntity(playershot\sprite):Delete playershot:Goto done
		If EntityZ(playershot\sprite)>1100 Or EntityZ(playershot\sprite)<-100 Then FreeEntity(playershot\sprite):Delete playershot:Goto done
		playershot\life=playershot\life-1
		If playershot\life<=0 Then FreeEntity(playershot\sprite):Delete playershot:Goto done
		
		If EntityCollided(playershot\sprite,coll_mazewall) Or EntityCollided(playershot\sprite,coll_mazefloor) Then 
			For k=1 To CountCollisions(playershot\sprite)
				t=GetEntityType(CollisionEntity(playershot\sprite,k))
				If t=coll_mazewall Or t=coll_mazefloor Then
					cx#=CollisionX(playershot\sprite,k)
					cy#=CollisionY(playershot\sprite,k)
					cz#=CollisionZ(playershot\sprite,k)
					nx#=CollisionNX(playershot\sprite,k)
					ny#=CollisionNY(playershot\sprite,k)
					nz#=CollisionNZ(playershot\sprite,k)
					mazedamage.mazedamagetype=New mazedamagetype
					mazedamage\sprite=CopyEntity(ShotDamageSprite)
					PositionEntity mazedamage\sprite,cx,cy,cz
					AlignToVector mazedamage\sprite,nx,ny,nz,3
					MoveEntity mazedamage\sprite,0,0,1.5:TurnEntity mazedamage\sprite,0,180,0:TurnEntity mazedamage\sprite,0,0,Rand(0,359)
					For e=1 To 10:AddParticle(cx,cy,cz):Next
					
					AddExplosion(cx,cy,cz,1)
					AddSmoke(cx,cy,cz,0.01)
					AddExplosionSound(cx,cy,cz,1)
					FreeEntity(playershot\sprite):Delete playershot:Goto done
					Exit
				EndIf
			Next
		EndIf
		
		;Hit an enemy?
		If EntityCollided(playershot\sprite,coll_enemyrobot) Then 
			ent=CollisionEntity(playershot\sprite,1)
			For enemy.enemytype=Each enemytype
				If ent=enemy\entity Then DamageEnemyRobot(enemy,1)
			Next
			AddExplosion(EntityX(playershot\sprite),EntityY(playershot\sprite),EntityZ(playershot\sprite),1)
			FreeEntity playershot\sprite:Delete playershot
		EndIf	
		
		.done
	Next
End Function

Function AddRobotPiece(x,y,z,typ)
	robotpiece.robotpiecetype=New robotpiecetype
	robotpiece\entity=CopyEntity(RobotPieceMesh(typ))
	PositionEntity robotpiece\entity,x,y,z
	robotpiece\mx=Rnd(-5,5)
	robotpiece\my=Rnd(0,5)
	robotpiece\mz=Rnd(-5,5)
	robotpiece\rx=Rnd(-10,10)
	robotpiece\ry=Rnd(-10,10)
	robotpiece\rz=Rnd(-10,10)
	robotpiece\typ=typ
	EntityType robotpiece\entity,coll_robotpiece
	ResetEntity robotpiece\entity
End Function

Function UpdateRobotPieces()
	For robotpiece.robotpiecetype=Each robotpiecetype
		robotpiece\my=robotpiece\my-Gravity
		TranslateEntity robotpiece\entity,robotpiece\mx,robotpiece\my,robotpiece\mz
		TurnEntity robotpiece\entity,robotpiece\rx,robotpiece\ry,robotpiece\rz
		If EntityCollided(robotpiece\entity,coll_mazefloor) Then
			AddPermanentRobotPiece(EntityX(robotpiece\entity),4,EntityZ(robotpiece\entity),EntityYaw(robotpiece\entity),robotpiece\typ)
			FreeEntity robotpiece\entity:Delete robotpiece
		EndIf
	Next
End Function

Function AddPermanentRobotPiece(x,y,z,ry,typ)
	probotpiece.probotpiecetype=New probotpiecetype
	probotpiece\entity=CopyEntity(RobotPieceMesh(typ))
	PositionEntity probotpiece\entity,x,y,z
	RotateEntity probotpiece\entity,0,ry,0
End Function

Function AddEnemyRobot(x,z,node,evilhillary)
	enemy.enemytype=New enemytype
	If evilhillary=False Then 
		enemy\entity=CopyEntity(CyborgVixen) 
		enemy\bounce=0
	Else
		enemy\entity=CreateCube():EntityBox enemy\entity,-25,-25,-25,50,50,50:
		enemy\entity2=CopyEntity(EvilHillaryMesh)
		ScaleEntity enemy\entity2,0.5,0.5,0.5
		EntityParent enemy\entity2,enemy\entity
	EndIf
	enemy\shadow=CopyEntity(ShadowSprite,enemy\entity)
	EntityType enemy\entity,coll_enemyrobot
	PositionEntity enemy\entity,x,0+(25*evilhillary),z
	RotateEntity enemy\entity,0,Rand(0,359),0
	PositionEntity enemy\shadow,EntityX(enemy\entity),0.2,EntityZ(enemy\entity),1
	RotateEntity enemy\shadow,90,0,0
	enemy\gun1=CreatePivot(enemy\entity)
	enemy\gun2=CreatePivot(enemy\entity)
	MoveEntity enemy\gun1,-20,28,0
	MoveEntity enemy\gun2,20,28,0
	If evilhillary=1 Then ScaleSprite enemy\shadow,12,12
	enemy\lastnode=node
	enemy\destnode=node
	enemy\pa=0:enemy\ca=0
	If GameLevel<=5 Then enemy\hp=Rand(1,3)
	If GameLevel>=6 And GameLevel<=10 Then enemy\hp=Rand(3,7)
	If GameLevel>=11 And GameLevel<=20 Then enemy\hp=Rand(4,10)
	If GameLevel>20 Then enemy\hp=Rand(7,17)
	enemy\hp=enemy\hp+(100000*evilhillary)
	enemy\ft=0
	enemy\evilhillary=evilhillary:enemy\bounce=0
	SetCyborgAnim(enemy,1,0.25)
End Function

Function UpdateEnemyRobots()
	If LevelStartTimer<120 Or PlayerDeathTimer<>0 Then 
		For enemy.enemytype=Each enemytype:SetCyborgAnim(enemy,1,0.25):Next
		Return
	EndIf
	;If PlayerDeathTimer<>0 Then Return
	For enemy.enemytype=Each enemytype
		If Rand(1,1000)=1 And RobotTalkTimer=0 And enemy\evilhillary=False Then 
			EmitSound(Taunt(Rand(1,4)),enemy\entity)
			RobotTalkTimer=1
		EndIf
		If Rand(1,700)=1 And enemy\evilhillary=True Then EmitSound(Laugh(Rand(1,4)),enemy\entity)   ;Laughing sounds

		If RobotTalkTimer>0 Then RobotTalkTimer=RobotTalkTimer+1
		If RobotTalkTimer>1000 Then RobotTalkTimer=0
		;Face current node
		If IsTargetInArc(EntityX(enemy\entity),EntityZ(enemy\entity),EntityYaw(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode),5)=False Then
			If TurnEnemyRobotToTarget(EntityYaw(enemy\entity),EntityX(enemy\entity),EntityZ(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode))=True Then
				TurnEntity enemy\entity,0,-RobotTurnSpeed-(RobotTurnSpeed*enemy\evilhillary),0    ;right
			Else
				TurnEntity enemy\entity,0,RobotTurnSpeed+(RobotTurnSpeed*enemy\evilhillary),0     ;left
			EndIf
		EndIf
		
		;Has robot reached destination?
		reach=IsTargetCloserThan(EntityX(enemy\entity),EntityZ(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode),10)
		If reach=True Then
			;Where next? (the connected node nearest the player)
			For n=1 To 5:NextNodeDist(n)=10000:NextNodeDistNo(n)=0:Next
			For n=1 To 5
				If MazeNodeConn(MazeLevel,enemy\destnode,n)=0 Then 
					NumConn=n-1:Exit
				Else
					nodeno=MazeNodeConn(MazeLevel,enemy\destnode,n)
					tx=MazeNodeX(nodeno):tz=MazeNodeZ(nodeno)
					NextNodeDist(n)=Sqr((EntityX(Lysozyme)-tx)^2+(EntityZ(Lysozyme)-tz)^2)
				EndIf
				NextNodeDistNo(n)=MazeNodeConn(MazeLevel,enemy\destnode,n)
			Next
			enemy\destnode=NextNodeDistNo(1)
			d1=NextNodeDist(1):n1=NextNodeDistNo(1)
			d2=NextNodeDist(2):n2=NextNodeDistNo(2)
			d3=NextNodeDist(3):n3=NextNodeDistNo(3)
			d4=NextNodeDist(4):n4=NextNodeDistNo(4)
			d5=NextNodeDist(5):n5=NextNodeDistNo(5)
			
			If d1<d2 And d1<d3 And d1<d4 And d1<d5 Then enemy\destnode=n1
			If d2<d1 And d2<d3 And d2<d4 And d2<d5 Then enemy\destnode=n2
			If d3<d1 And d3<d2 And d3<d4 And d3<d5 Then enemy\destnode=n3
			If d4<d1 And d4<d2 And d4<d3 And d4<d5 Then enemy\destnode=n4
			If d5<d1 And d5<d2 And d5<d3 And d5<d4 Then enemy\destnode=n5
			
			If Rand(1,3)=1 And enemy\evilhillary=False Then
				While MazeNodeConn(MazeLevel,enemy\lastnode,nn)=0
					nn=Rand(1,5)				
				Wend
				enemy\destnode=MazeNodeConn(MazeLevel,enemy\lastnode,nn)
			EndIf
			
			enemy\lastnode=enemy\destnode

		EndIf
		
		If AnimSeq(enemy\entity)=3 And AnimTime(enemy\entity)>=2 Then Animate enemy\entity,1,0.35,2,1:enemy\pa=2:enemy\ca=2
		
		SetCyborgAnim(enemy,2,RobotAnimSpeed)
		
		If AnimSeq(enemy\entity)<>3 Then MoveEntity enemy\entity,0,0,RobotSpeed+(RobotSpeed*enemy\evilhillary)
		
		If enemy\evilhillary=1 Then
			enemy\bounce=enemy\bounce+2
			If enemy\bounce>359 Then enemy\bounce=enemy\bounce-360
			PositionEntity enemy\entity,EntityX(enemy\entity),125+(100*Sin(enemy\bounce)),EntityZ(enemy\entity)
			RotateEntity enemy\entity2,0,enemy\spin,0,True
			enemy\spin=enemy\spin+5:If enemy\spin>359 Then enemy\spin=enemy\spin-360
			PositionEntity enemy\shadow,EntityX(enemy\entity),0.2,EntityZ(enemy\entity),1
		EndIf
		
		;Shooting!
		enemy\ft=enemy\ft+1
		If enemy\ft>RobotShootingSpeed Then enemy\ft=RobotShootingSpeed
		cl=IsTargetCloserThan(EntityX(enemy\entity),EntityZ(enemy\entity),EntityX(Lysozyme),EntityZ(Lysozyme),600)
		ar=IsTargetInArc(EntityX(enemy\entity),EntityZ(enemy\entity),EntityYaw(enemy\entity),EntityX(Lysozyme),EntityZ(Lysozyme),45)
		If cl=True And ar=True And enemy\ft>=RobotShootingSpeed And GameLevel>1 And enemy\evilhillary=False Then 
			;AddEnemyShot(EntityX(enemy\entity),25,EntityZ(enemy\entity),False)
			AddEnemyShot(EntityX(enemy\gun1,True),EntityY(enemy\gun1,True),EntityZ(enemy\gun1,True),False)
			AddEnemyShot(EntityX(enemy\gun2,True),EntityY(enemy\gun2,True),EntityZ(enemy\gun2,True),False)
			
			enemy\ft=0:EmitSound CyborgShootSound,enemy\entity
			SetCyborgAnim(enemy,3,0.1)
		EndIf
		
		If cl=True And enemy\evilhillary=True And Rand(1,40)=1 Then
			AddEnemyShot(EntityX(enemy\entity),EntityY(enemy\entity),EntityZ(enemy\entity),True)
		EndIf
		
		.done2
	Next
End Function

Function DamageEnemyRobot(enemy.enemytype,dam)
	enemy\hp=enemy\hp-dam   ;Damage!
	If enemy\hp<=0 Then
		cx=EntityX(enemy\entity):cy=EntityY(enemy\entity):cz=EntityZ(enemy\entity) 
		AddExplosionSound(cx,cy,cz,2)
		For e=1 To 40:AddParticle(cx,cy,cz):Next
		AddSmoke(cx,cy,cz,0.0035)
		For rp=1 To 29:AddRobotPiece(cx,cy+25,cz,rp):Next

			For splat=1 To 3
				mazedamage.mazedamagetype=New mazedamagetype
				mazedamage\sprite=CopyEntity(ShotDamageSprite)
				PositionEntity mazedamage\sprite,cx,0.2,cz
				RotateEntity mazedamage\sprite,90,0,0
				TurnEntity mazedamage\sprite,0,0,Rand(0,359)
				ScaleSprite mazedamage\sprite,50,50
				AddExplosion(cx,cy+25,cz,2)
			Next
			AddFire(cx,cz)
			If Rand(1,6)=1 And ChannelPlaying(NikkiTauntChannel)=False Then NikkiTauntChannel=PlaySound(NikkiTaunt(Rand(1,6)))
			FreeEntity enemy\shadow
			FreeEntity enemy\entity
			Delete enemy
		Score=Score+50:ScoreForLevel=ScoreForLevel+50
		CurrentRobotsInMaze=CurrentRobotsInMaze-1
		If CurrentRobotsInMaze=0 Then Score=Score+(2*OriginalRobotsInMaze*50):ScoreForLevel=ScoreForLevel+(2*OriginalRobotsInMaze*50):PlaySound MusicCyborgsDestroyed
		If Score>=NextExtraLife Then Lives=Lives+1:NextExtraLife=NextExtraLife+ExtraLife:PlaySound MusicExtraLife
	EndIf
End Function

Function IsTargetCloserThan(x,z,tx,tz,dist)
	d#=Sqr((tz-z)^2+(tx-x)^2)
	If d>dist Then Return False Else Return True
End Function

Function TurnEnemyRobotToTarget(yaw#,rox#,roz#,targx,targz)    ;true=right  false=left
	ro#=ATan2(targz-roz,targx-rox)
	
	ro1=ro-yaw-90
	If ro1>=360 Then ro1=ro1-360
	If ro1<0 Then ro1=ro1+360
	If ro1>=0 And ro1<=180 Then Return False Else Return True
End Function

Function IsTargetInArc(x,z,ang#,tx,tz,arc)
	ro#=ATan2(tz-z,tx-x)
	
	ro1=ro-ang-90
	ro1=ro1+180
	If ro1>=360 Then ro1=ro1-360
	If ro1<0 Then ro1=ro1+360
	
	If ro1>=180-arc And ro1<=180+arc Then Return True
	
	;If ro1>=0 And ro1<=arc Then Return True
	;If ro1>=360-arc And ro1<360 Then Return True
	Return False

End Function


Function AddEnemyShot(x,y,z,superenemy)
	c=0
	For enemyshot.enemyshottype=Each enemyshottype:c=c+1:Next
	If c>=10 Then Return

	enemyshot.enemyshottype=New enemyshottype
	If superenemy=False Then enemyshot\sprite=CopyEntity(EnemyShotSprite) Else enemyshot\sprite=CopyEntity(SuperEnemyShotSprite)
	enemyshot\superenemy=superenemy
	enemyshot\rotang=0
	EntityType enemyshot\sprite,coll_enemyshot
	EntityRadius enemyshot\sprite,5
	PositionEntity enemyshot\sprite,x,y,z
	ResetEntity enemyshot\sprite
	MoveEntity Lysozyme,0,20,0
	PointEntity enemyshot\sprite,Lysozyme
	MoveEntity Lysozyme,0,-20,0
End Function

Function UpdateEnemyShots()
	For enemyshot.enemyshottype=Each enemyshottype
		If enemyshot\superenemy=False Then MoveEntity enemyshot\sprite,0,0,RobotShotSpeed Else MoveEntity enemyshot\sprite,0,0,15

		enemyshot\rotang=enemyshot\rotang+5
		If enemyshot\rotang>359 Then enemyshot\rotang=0
		RotateSprite enemyshot\sprite,enemyshot\rotang

		If EntityCollided(enemyshot\sprite,coll_mazewall) Or EntityCollided(enemyshot\sprite,coll_mazefloor) Then 
			For k=1 To CountCollisions(enemyshot\sprite)
				If GetEntityType(CollisionEntity(enemyshot\sprite,k))=coll_mazewall Or GetEntityType (CollisionEntity(enemyshot\sprite,k))=coll_mazefloor Then
					cx#=CollisionX(enemyshot\sprite,k)
					cy#=CollisionY(enemyshot\sprite,k)
					cz#=CollisionZ(enemyshot\sprite,k)
					nx#=CollisionNX(enemyshot\sprite,k)
					ny#=CollisionNY(enemyshot\sprite,k)
					nz#=CollisionNZ(enemyshot\sprite,k)
					mazedamage.mazedamagetype=New mazedamagetype
					mazedamage\sprite=CopyEntity(ShotDamageSprite)
					PositionEntity mazedamage\sprite,cx,cy,cz
					AlignToVector mazedamage\sprite,nx,ny,nz,3
					MoveEntity mazedamage\sprite,0,0,1:TurnEntity mazedamage\sprite,0,180,0:TurnEntity mazedamage\sprite,0,0,Rand(0,359)
					If enemyshot\superenemy=True Then ScaleSprite mazedamage\sprite,60,60
					For e=1 To 10:AddParticle(cx,cy,cz):Next
					If enemyshot\superenemy=False Then 
						AddExplosionSound(cx,cy,cz,1)
						AddExplosion(cx,cy,cz,1)
					Else 
						AddExplosionSound(cx,cy,cz,2)
						AddExplosion(cx,cy,cz,2)
					EndIf
					AddSmoke(cx,cy,cz,0.01)
					FreeEntity enemyshot\sprite:Delete enemyshot
					Goto done3
				EndIf
			Next
		EndIf
		
		If EntityCollided(enemyshot\sprite,coll_Lysozyme) Then
			If enemyshot\superenemy=False Then DamagePlayer(Rand(10,30)) Else DamagePlayer(Rand(30,70))
			AddExplosion(EntityX(enemyshot\sprite),EntityY(enemyshot\sprite),EntityZ(enemyshot\sprite),1)
			FreeEntity enemyshot\sprite:Delete enemyshot:Goto done3
		EndIf
		
		If EntityX(enemyshot\sprite)>1000 Or EntityX(enemyshot\sprite)<0 Then FreeEntity enemyshot\sprite:Delete enemyshot:Goto done3
		If EntityZ(enemyshot\sprite)>1000 Or EntityZ(enemyshot\sprite)<0 Then FreeEntity enemyshot\sprite:Delete enemyshot
		
		.done3
	Next
End Function

Function AddParticle(x,y,z)
	particle.particletype=New particletype
	particle\sprite=CopyEntity(ParticleSprite)
	PositionEntity particle\sprite,x,y,z
	particle\mx=Rnd(-3,3)
	particle\my=Rnd(-3,3)
	particle\mz=Rnd(-3,3)
End Function

Function UpdateParticles()
	For particle.particletype=Each particletype
		particle\my=particle\my-Gravity
		MoveEntity particle\sprite,particle\mx,particle\my,particle\mz
		If EntityY(particle\sprite)<0 Then FreeEntity(particle\sprite):Delete particle
	Next
End Function

Function AddExplosion(x,y,z,typ)  ;typ 1=small   typ 2=larger
	explosion.explosiontype=New explosiontype
	explosion\sprite1=CopyEntity(ExplosionSprite)
	RotateEntity explosion\sprite1,0,0,0
	explosion\size=5
	explosion\alpha=1
	explosion\typ=typ
	PositionEntity explosion\sprite1,x,y,z	
End Function

Function UpdateExplosions()
	For explosion.explosiontype=Each explosiontype
		If explosion\typ=1 Then sp#=0.04 Else sp#=0.02
		ScaleSprite explosion\sprite1,explosion\size,explosion\size
		explosion\alpha=explosion\alpha-sp:explosion\size=explosion\size*1.15
		EntityAlpha explosion\sprite1,explosion\alpha
		If explosion\alpha<=0 Then 
			FreeEntity explosion\sprite1
			Delete explosion
		EndIf
	Next
End Function

Function DamagePlayer(dam)
	If health<=0 Then Return
	Health=Health-dam
	CameraSpriteAlpha=1
	If Health<=0 Then Health=0:PlayerDeathTimer=1:PrevView=CurrView:Return
	PlaySound Grunt(Rand(1,6))
End Function

Function NewPlayer()
	Lives=Lives-1:Health=100
	If Lives<0 Then GameOver
	ShowEntity Lysozyme
	PositionEntity Lysozyme,500,0,500,True:RotateEntity Lysozyme,0,0,0:ResetEntity Lysozyme
	PositionEntity LysozymeCameraPivot,0,55,0
	RotateEntity LysozymeCameraPivot,0,0,0
	RotateEntity camera,0,0,0
	RotateEntity AimingGuide,0,0,0
	RotateEntity PlayerShotOrigin,0,0,0
	ppa=6:SetLysoAnim(1,0.1)
	CurrView=PrevView
End Function

Function GameOver()
	StopChannel(NikkiTauntChannel)
	StopChannel(MusicLoopChannel)
	StopChannel(NeroGripeChannel)
	Cls
	DrawBlock YouLoseScreenImg,0,0
	mus=PlaySound(YouLoseScreenMusic)
	SetFont LargeFont
	Text 400,200,"GAME OVER",True
	Text 400,500,"PRESS SPACE TO PLAY AGAIN",True
	Text 400,450,"PRESS ESC TO QUIT",True
	Flip
	While Not KeyDown(1)
		kk=GetKey()
		If kk=Asc(" ") Then
			StopChannel(mus)
			GameLevel=0:Score=0:Lives=5:ppa=0:pca=0
			NextExtraLife=ExtraLife
			NewLevel(1):NewPlayer
			Return
		EndIf
	Wend
	StopChannel(mus)
	End
End Function

Function GameOverYouWin()
	StopChannel(NikkiTauntChannel)
	StopChannel(MusicLoopChannel)
	StopChannel(NeroGripeChannel)
	Cls
	DrawBlock YouWinScreenImg,0,0
	mus=PlaySound(YouWinScreenMusic)
	SetFont LargeFont
	Text 400,400,"PRESS SPACE TO PLAY AGAIN",True
	Text 400,350,"PRESS ESC TO QUIT",True
	Flip
	While Not KeyDown(1)
		kk=GetKey()
		If kk=Asc(" ") Then
			StopChannel(mus)
			GameLevel=0:Score=0:Lives=5:ppa=0:pca=0
			NextExtraLife=ExtraLife
			NewLevel(1):NewPlayer
			Return
		EndIf
	Wend
	StopChannel(mus)
	End
End Function			

Function AddExplosionSound(x,y,z,size)  ;1=small 2=large
	explosionsound.explosionsoundtype=New explosionsoundtype
	explosionsound\entity=CopyEntity(ExplosionSoundPivot)
	PositionEntity explosionsound\entity,x,y,z
	If size=1 Then EmitSound SmallExplosionSound,explosionsound\entity
	If size=2 Then EmitSound LargeExplosionSound,explosionsound\entity
End Function

Function SetLysoAnim(an,spd#)
	If ppa=an Then Return
	If an>=1 And an<=3 Then Animate Lysozyme,1,spd,an,1
	If an=4 Then Animate Lysozyme,1,-0.5,2,1
	ppa=pca:pca=an
End Function

Function SetCyborgAnim(enemy.enemytype,an,spd#)
	If enemy\evilhillary=True Then Return
	;If AnimSeq(enemy\entity)=3 And AnimTime(enemy\entity)<2 Then Return
	If enemy\pa=an Then Return
	If an<>3 Then Animate enemy\entity,1,spd,an,1 Else Animate enemy\entity,3,spd,an,1
	enemy\pa=enemy\ca:enemy\ca=an
End Function